VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Mainform 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Multi-Channel Multi-Point Acquisition - Internal Clock"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8535
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5655
   ScaleWidth      =   8535
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Caption         =   "Group By"
      Height          =   1095
      Left            =   240
      TabIndex        =   19
      Top             =   4200
      Width           =   3855
      Begin VB.OptionButton channelGroupingOption 
         Caption         =   "Channel"
         Height          =   255
         Left            =   360
         TabIndex        =   7
         Top             =   720
         Width           =   1815
      End
      Begin VB.OptionButton scanOrderOption 
         Caption         =   "Scan Number"
         Height          =   255
         Left            =   360
         TabIndex        =   6
         Top             =   360
         Value           =   -1  'True
         Width           =   2175
      End
   End
   Begin VB.TextBox maxValueTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   3
      Text            =   "10.00"
      Top             =   1560
      Width           =   1575
   End
   Begin VB.TextBox minValueTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   2
      Text            =   "-10.00"
      Top             =   1080
      Width           =   1575
   End
   Begin VB.Frame acquisitionResultsGroupBox 
      Caption         =   "Acquisition Results"
      Height          =   3975
      Left            =   4320
      TabIndex        =   10
      Top             =   240
      Width           =   3975
      Begin MSComctlLib.ListView acquisitionDataGrid 
         Height          =   3135
         Left            =   360
         TabIndex        =   11
         TabStop         =   0   'False
         Top             =   600
         Width           =   3255
         _ExtentX        =   5741
         _ExtentY        =   5530
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
      Begin VB.Label acquisitionDataLabel 
         Caption         =   "Acquisition Data (V):"
         Height          =   255
         Left            =   360
         TabIndex        =   15
         Top             =   360
         Width           =   1815
      End
   End
   Begin VB.TextBox samplesPerChannelTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   4
      Text            =   "1000"
      Top             =   2880
      Width           =   1575
   End
   Begin VB.TextBox frequencyTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   5
      Text            =   "1000.00"
      Top             =   3360
      Width           =   1575
   End
   Begin VB.CommandButton startCommandButton 
      Caption         =   "&Start"
      Height          =   375
      Left            =   5640
      TabIndex        =   0
      Top             =   4920
      Width           =   1215
   End
   Begin VB.Frame channelParameterGroupBox 
      Caption         =   "Channel Parameters"
      Height          =   1935
      Left            =   240
      TabIndex        =   8
      Top             =   240
      Width           =   3855
      Begin VB.TextBox physicalChannelTextBox 
         Height          =   285
         Left            =   2040
         TabIndex        =   1
         Text            =   "Dev1/ai0:1"
         Top             =   360
         Width           =   1575
      End
      Begin VB.Label physicalChannelLabel 
         Caption         =   "Physical Channel:"
         Height          =   255
         Left            =   360
         TabIndex        =   12
         Top             =   360
         Width           =   1455
      End
      Begin VB.Label minValueLabel 
         Caption         =   "Minimum Value (V):"
         Height          =   255
         Left            =   360
         TabIndex        =   13
         Top             =   840
         Width           =   1455
      End
      Begin VB.Label maxValueLabel 
         Caption         =   "Maximum Value (V):"
         Height          =   255
         Left            =   360
         TabIndex        =   14
         Top             =   1320
         Width           =   1455
      End
   End
   Begin VB.Frame timingParameterGroupBox 
      Caption         =   "Timing Parameters"
      Height          =   1575
      Left            =   240
      TabIndex        =   16
      Top             =   2400
      Width           =   3855
      Begin VB.Label rateLabel 
         Caption         =   "Rate (Hz):"
         Height          =   255
         Left            =   360
         TabIndex        =   18
         Top             =   960
         Width           =   1455
      End
      Begin VB.Label samplesPerChannelLabel 
         Caption         =   "Samples / Channel:"
         Height          =   255
         Left            =   360
         TabIndex        =   17
         Top             =   480
         Width           =   1575
      End
   End
   Begin VB.Label acquiringLabel 
      Height          =   255
      Left            =   4680
      TabIndex        =   9
      Top             =   4440
      Visible         =   0   'False
      Width           =   3255
   End
End
Attribute VB_Name = "Mainform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*********************************************************************
' Visual Basic 6.0 Example program:
'    MultiplePointAcqIntClk.frm
'
' Example Category:
'    AI
'
' Description:
'    This example demonstrates how to acquire multiple
'    readings from a slowly varying signal.
'
' Instructions for Running:
'
'   1.  Select the physical channel(s) to correspond to where your signal
'       is input on the DAQ device.
'   2.  Enter the minimum and maximum voltages.
'   Note:  For better accuracy try to match the input range to the
'          expected voltage level of the measured signal.
'
' Steps:
'   1.  Create a new analog input task.
'   2.  Create an analog input voltage channel.
'   3.  Read a finite amount of samples from the specified channel.
'   4.  Call the StopTask() module to stop and clear the task.
'   5.  Display an error if any.
'
' I/O Connections Overview:
'   Make sure your signal input terminal matches the physical channel
'   control.  In the default case wire your signal to the ai0 and ai1 pins on your
'   DAQ Device.  For more information on the input and output terminals
'   for your device, open the NI-DAQmx Help, and refer to the NI-DAQmx Device
'   Terminals and Device Considerations books in the table of contents.
'
'*********************************************************************/
    
Option Explicit
Private data() As Double
Private taskHandle As Long
Private taskIsRunning As Boolean

Private Sub startCommandButton_Click()
    Dim sampsPerChanRead As Long
    Dim numChannels As Long
    Dim fillMode As DAQmxFillMode
    Dim bufferSize As Long
    Dim numSampsPerChannel As Long
    Dim arraySizeInSamps As Long
    
    On Error GoTo ErrorHandler
        
    startCommandButton.Enabled = False
    acquisitionDataGrid.ListItems.Clear
    acquisitionDataGrid.ColumnHeaders.Clear
    
    If ValidateControlValues Then
        startCommandButton.Enabled = True
        Exit Sub
    End If
    
    If scanOrderOption.Value = True Then
        fillMode = DAQmx_Val_GroupByScanNumber
    Else
        fillMode = DAQmx_Val_GroupByChannel
    End If
    bufferSize = 255
    numSampsPerChannel = CLng(samplesPerChannelTextBox.Text)
    
    'Create the DAQmx task.
    DAQmxErrChk DAQmxCreateTask("", taskHandle)
    taskIsRunning = True
 
    'Add an analog input channel to the task.
    DAQmxErrChk DAQmxCreateAIVoltageChan(taskHandle, physicalChannelTextBox.Text, "", _
                    DAQmx_Val_Cfg_Default, minValueTextBox.Text, maxValueTextBox.Text, _
                    DAQmx_Val_VoltageUnits1_Volts, "")
                    
    'Configure task for finite sample acquisition and read in data
    DAQmxErrChk DAQmxCfgSampClkTiming(taskHandle, "OnboardClock", frequencyTextBox.Text, DAQmx_Val_Rising, _
                    DAQmx_Val_AcquisitionType_FiniteSamps, CLng(samplesPerChannelTextBox.Text))
    DAQmxErrChk DAQmxGetTaskNumChans(taskHandle, numChannels)
    arraySizeInSamps = numSampsPerChannel * numChannels
    ReDim data(arraySizeInSamps)
    
    acquiringLabel.Visible = True
    acquiringLabel.Caption = "Acquiring..."
    DAQmxErrChk DAQmxReadAnalogF64(taskHandle, numSampsPerChannel, 10#, _
                    fillMode, data(0), arraySizeInSamps, sampsPerChanRead, ByVal 0&)
    
    'Populate the listView
    PopulateListView numChannels, fillMode, sampsPerChanRead
 
    'Call the StopTask module to stop the DAQmx task.
    StopTask
    
    startCommandButton.Enabled = True
    
     ' Display a message indicating the number of samples per channel read.
    acquiringLabel.Caption = "Samples per channel read = " & sampsPerChanRead
Exit Sub
    
ErrorHandler:
    If taskIsRunning = True Then
        DAQmxStopTask taskHandle
        DAQmxClearTask taskHandle
        taskIsRunning = False
    End If
    acquiringLabel.Visible = False
    startCommandButton.Enabled = True
    MsgBox "Error: " & Err.Number & " " & Err.Description, , "Error"
End Sub
    
Private Sub StopTask()
    'Done!
    DAQmxErrChk DAQmxStopTask(taskHandle)
    DAQmxErrChk DAQmxClearTask(taskHandle)
    taskIsRunning = False
End Sub

Private Function ValidateControlValues()
    ValidateControlValues = 0
    
    If maxValueTextBox.Text = "" Or minValueTextBox.Text = "" Or samplesPerChannelTextBox.Text = "" Or frequencyTextBox.Text = "" Then
        MsgBox "Please fill in all empty fields.", , Error
        ValidateControlValues = 1
    End If
End Function

Private Sub PopulateListView(numChannels As Long, fillMode As Long, sampsPerChanRead As Long)
    Dim count As Long
    Dim i As Long
    Dim temp_i As Long
    Dim j As Long
    Dim item As ListItem
        
    'Physical channels parsing and ListView implementation
    If numChannels > 1 Then
        SetupListViewColumns (numChannels)
        count = 0
        i = 0
        temp_i = 0
        j = 1
        If fillMode = DAQmx_Val_GroupByChannel Then
            ' Chan0Data0, Chan0Data1, Chan0Data2...,Chan1Data0, Chan1Data1, Chan1Data2...,Chan2Data0,Chan2Data1,Chan2Data2...
            For count = 0 To sampsPerChanRead - 1
                i = temp_i
                Set item = acquisitionDataGrid.ListItems.Add(, , Strings.FormatNumber(data(i), 6))
                i = i + sampsPerChanRead
                For j = 1 To numChannels - 1
                    item.SubItems(j) = Strings.FormatNumber(data(i), 6)
                    i = i + sampsPerChanRead
                Next j
                temp_i = temp_i + 1
            Next count
        Else 'DAQmx_Val_GroupByScanNumber - Use this fill mode when possible since this is faster
            ' Chan0Data0, Chan1Data0, Chan2Data0...,Chan0Data1, Chan1Data1, Chan2Data1...,Chan0Data2,Chan1Data2,Chan2Data2...
            For count = 0 To sampsPerChanRead - 1
                Set item = acquisitionDataGrid.ListItems.Add(, , Strings.FormatNumber(data(i), 6))
                i = i + 1
                For j = 1 To numChannels - 1
                    item.SubItems(j) = Strings.FormatNumber(data(i), 6)
                    i = i + 1
                Next j
            Next count
        End If
        
    Else 'Only one physical channel - no grouping involved
        count = 0
        i = 0
        acquisitionDataGrid.ColumnHeaders.Add , , physicalChannelTextBox.Text
        acquisitionDataGrid.View = lvwReport
        While i < sampsPerChanRead
          Set item = acquisitionDataGrid.ListItems.Add(, , Strings.FormatNumber(data(i), 6))
          i = i + 1
        Wend
    End If
End Sub

Private Sub SetupListViewColumns(numChannels As Long)
    Dim channelList As String * 255
    Dim tmpString As String
    Dim tmpChannelList As String
    Dim commaStart As Long
    Dim bufferSize As Long
    Dim count As Long
    Dim i As Long
    bufferSize = 255

    DAQmxErrChk DAQmxGetTaskChannels(taskHandle, channelList, bufferSize)

    'Physical channels parsing and ListView implementation
    While Mid(channelList, count + 1, 1) <> Chr$(0)
        count = count + 1
    Wend
    tmpChannelList = Mid(channelList, 1, count)
    count = 0
    commaStart = 1
    For i = 0 To Len(tmpChannelList)
        While Mid(tmpChannelList, i + 1, 1) <> "," And i < Len(tmpChannelList)
            i = i + 1
            count = count + 1
        Wend
        tmpString = Mid(tmpChannelList, commaStart, count)
        commaStart = i + 2
        acquisitionDataGrid.ColumnHeaders.Add , , tmpString
        acquisitionDataGrid.View = lvwReport
        count = 0
    Next
End Sub
Private Sub Form_Load()
    taskIsRunning = False
    acquiringLabel.Visible = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Quit the program.
    If taskIsRunning = True Then
        StopTask
    End If
    End
End Sub






